import logging

from pyalchemybiz.lib.base import *
from pyalchemybiz.model import customer, meta, person

log = logging.getLogger(__name__)


class CustomerController(BaseController):

    def index(self):
        sess = meta.Session()
        cust_q = sess.query(customer.Customer)
        c.customers = cust_q.all()
        return render('/derived/customer/index.mako')

    def create(self):
        sess = meta.Session()
        return render('/derived/customer/create.mako')

    def edit(self, id):
        sess = meta.Session()
        cust_q = sess.query(customer.Customer)
        c.customer = cust_q.filter(customer.Customer.id==id).one()
        return render('/derived/customer/edit.mako')

    def delete(self, id):
        sess = meta.Session()
        cust_q = sess.query(customer.Customer)
        cust = cust_q.filter(customer.Customer.id==id).one()
        sess.delete(cust.person)
        sess.delete(cust)
        sess.commit()

        redirect_to(action='index')

    def process_create(self):
        sess = meta.Session()
        cust = customer.Customer()
        sess.save(cust)
        cust.person = person.Person()
        cust.person.firstname = request.params['firstname']
        cust.person.lastname = request.params['lastname']
        sess.save(cust.person)
        sess.commit()

        redirect_to(action='index')

    def process_edit(self, id):
        sess = meta.Session()
        cust_q = sess.query(customer.Customer)
        cust = cust_q.filter(customer.Customer.id==id).one()
        cust.person.firstname = request.params['firstname']
        cust.person.lastname = request.params['lastname']
        sess.add(cust.person)
        sess.commit()

        redirect_to(action='index')
